// Copyright (c) 2016 ETH-Zurich. All rights reserved.
// Use of this source code is governed by a BSD-style license that
// can be found in the LICENSE file.

#ifndef _TASKS_TASK_GLOBAL_H_635106f3226c46d3d114158785752466
#define _TASKS_TASK_GLOBAL_H_635106f3226c46d3d114158785752466

// we allow external macros to be defined which are executed before and after finally changing the
// task
#ifndef EXTERNAL_HOOK_RUN_OTHER_TASK_START
	#define EXTERNAL_HOOK_RUN_OTHER_TASK_START() {}
#endif

#ifndef EXTERNAL_HOOK_RUN_OTHER_TASK_STOP
	#define EXTERNAL_HOOK_RUN_OTHER_TASK_STOP() {}
#endif

#ifndef EXTERNAL_HOOK_RUN_INIT_THREADS
	#define EXTERNAL_HOOK_RUN_INIT_THREADS() {}
#endif

namespace tinympi {
namespace tasks {

using thread_active = std::true_type;
using thread_inactive = std::false_type;

class LocalTask;
namespace impl {

	void add_to_scheduler(LocalTask* task);

} // END NAMESPACE impl

} // END NAMESPACE tasks
} // END NAMESPACE tinympi

#endif // _TASKS_TASK_GLBOAL_H_
