// Copyright (c) 2016 ETH-Zurich. All rights reserved.
// Use of this source code is governed by a BSD-style license that
// can be found in the LICENSE file.

#ifndef _TASKS_TASK_IDENTIFIER_H_635106f3226c46d3d114158785752466
#define _TASKS_TASK_IDENTIFIER_H_635106f3226c46d3d114158785752466

#include "global.h"

namespace tinympi {

namespace impl {
	struct BaseRequest;
}

namespace tasks {

class Task;

namespace impl {

	// abbreviations for functions that are referred from the task
	using isend_function_t = int(*)(void*, buflen_t, Task*, tag_t, context_id_t,
			tinympi::impl::BaseRequest**);
	using post_knownsource_recv_req_t = int(*)(void*, buflen_t, const Task*, tag_t,
			context_id_t, tinympi::impl::BaseRequest**);

} // END NAMESPACE impl


} // END NAMESPACE tasks
} // END NAMESPACE tinympi


#endif // _TASKS_TASK_IDENTIFIER_H_
